#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK36x36x36TN36x36x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=36, NB=36, KB=36, 
 * lda=36, ldb=36, ldc=0, mu=3, nu=4, ku=36, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.9.35)
 */
{
   const double *stM = A + 1296;
   const double *stN = B + 1296;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*4)/(36*36);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 36
   const int incAm = 72, incAn = -1296;
   #define incBk 36
   const int incBm = -36, incBn = 144;
   #define incCm 3
   const int incCn = (((ldc) << 2)) - 36;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[36];
         rA2 = pA0[72];
         rB1 = pB0[36];
         rC0_0 = rA0 * rB0;
         rB2 = pB0[72];
         rC1_0 = rA1 * rB0;
         rB3 = pB0[108];
         rC2_0 = rA2 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC2_3 = rA2 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[37];
         rA2 = pA0[73];
         rB1 = pB0[37];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[73];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[109];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[38];
         rA2 = pA0[74];
         rB1 = pB0[38];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[74];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[110];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[39];
         rA2 = pA0[75];
         rB1 = pB0[39];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[75];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[111];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[40];
         rA2 = pA0[76];
         rB1 = pB0[40];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[76];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[112];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA0[41];
         rA2 = pA0[77];
         rB1 = pB0[41];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[77];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[113];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA0[42];
         rA2 = pA0[78];
         rB1 = pB0[42];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[78];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[114];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA0[43];
         rA2 = pA0[79];
         rB1 = pB0[43];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[79];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[115];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA0[44];
         rA2 = pA0[80];
         rB1 = pB0[44];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[80];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[116];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA0[45];
         rA2 = pA0[81];
         rB1 = pB0[45];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[81];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[117];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA0[46];
         rA2 = pA0[82];
         rB1 = pB0[46];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[82];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[118];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA0[47];
         rA2 = pA0[83];
         rB1 = pB0[47];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[83];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[119];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA0[48];
         rA2 = pA0[84];
         rB1 = pB0[48];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[84];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[120];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA0[49];
         rA2 = pA0[85];
         rB1 = pB0[49];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[85];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[121];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA0[50];
         rA2 = pA0[86];
         rB1 = pB0[50];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[86];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[122];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA0[51];
         rA2 = pA0[87];
         rB1 = pB0[51];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[87];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[123];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA0[52];
         rA2 = pA0[88];
         rB1 = pB0[52];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[88];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[124];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA0[53];
         rA2 = pA0[89];
         rB1 = pB0[53];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[89];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[125];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA0[54];
         rA2 = pA0[90];
         rB1 = pB0[54];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[90];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[126];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA0[55];
         rA2 = pA0[91];
         rB1 = pB0[55];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[91];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[127];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA0[56];
         rA2 = pA0[92];
         rB1 = pB0[56];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[92];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[128];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA0[57];
         rA2 = pA0[93];
         rB1 = pB0[57];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[93];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[129];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA0[58];
         rA2 = pA0[94];
         rB1 = pB0[58];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[94];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[130];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA0[59];
         rA2 = pA0[95];
         rB1 = pB0[59];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[95];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[131];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA0[60];
         rA2 = pA0[96];
         rB1 = pB0[60];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[96];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[132];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rA1 = pA0[61];
         rA2 = pA0[97];
         rB1 = pB0[61];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[97];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[133];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA0[62];
         rA2 = pA0[98];
         rB1 = pB0[62];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[98];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[134];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rA1 = pA0[63];
         rA2 = pA0[99];
         rB1 = pB0[63];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[99];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[135];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA0[64];
         rA2 = pA0[100];
         rB1 = pB0[64];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[100];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[136];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rA1 = pA0[65];
         rA2 = pA0[101];
         rB1 = pB0[65];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[101];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[137];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA0[66];
         rA2 = pA0[102];
         rB1 = pB0[66];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[102];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[138];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rA1 = pA0[67];
         rA2 = pA0[103];
         rB1 = pB0[67];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[103];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[139];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA0[68];
         rA2 = pA0[104];
         rB1 = pB0[68];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[104];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[140];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rA1 = pA0[69];
         rA2 = pA0[105];
         rB1 = pB0[69];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[105];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[141];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA0[70];
         rA2 = pA0[106];
         rB1 = pB0[70];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[106];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[142];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rA1 = pA0[71];
         rA2 = pA0[107];
         rB1 = pB0[71];
         rC0_0 += rA0 * rB0;
         rB2 = pB0[107];
         rC1_0 += rA1 * rB0;
         rB3 = pB0[143];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
