#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK60x60x60TT0x0x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=60, NB=60, KB=60, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.9.35)
 */
{
   const double *stM = A + (120*(lda));
   const double *stN = B + 120;
   const double *pfA = A + M;
   #define incAk 8
   const int incAm = ((((((lda) << 1)+lda) - 60) << 1)), incAn = -(120*(lda));
   const int incBk = (((ldb) << 1)), incBm = -(120*(ldb));
   #define incBn 8
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 6
   const int incCn = (((ldc) << 3)) - 120;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
         rC2_0 = pC0[4];
         rC0_1 = *pC1;
         rC1_1 = pC1[2];
         rC2_1 = pC1[4];
         rC0_2 = *pC2;
         rC1_2 = pC2[2];
         rC2_2 = pC2[4];
         rC0_3 = *pC3;
         rC1_3 = pC3[2];
         rC2_3 = pC3[4];
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA0 * rB1;
         m4 = rA1 * rB1;
         m5 = rA2 * rB1;

         for (k=56; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rA1 = pA1[2];
            rA2 = pA2[2];
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rA1 = pA1[4];
            rA2 = pA2[4];
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rA1 = pA1[6];
            rA2 = pA2[6];
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rA1 = pA1[8];
            rA2 = pA2[8];
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rA2 = pA2[2];
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC0_3 += m3;
         m3 = rA0 * rB1;
         rC1_3 += m4;
         m4 = rA1 * rB1;
         rC2_3 += m5;
         m5 = rA2 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rA2 = pA2[4];
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC0_3 += m3;
         m3 = rA0 * rB1;
         rC1_3 += m4;
         m4 = rA1 * rB1;
         rC2_3 += m5;
         m5 = rA2 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rA2 = pA2[6];
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC0_3 += m3;
         m3 = rA0 * rB1;
         rC1_3 += m4;
         m4 = rA1 * rB1;
         rC2_3 += m5;
         m5 = rA2 * rB1;
         pA0 += (((incAk0) << 1)+incAk0);
         pA1 += (((incAk0) << 1)+incAk0);
         pA2 += (((incAk0) << 1)+incAk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         pB0 += incBk0;
         rC0_2 += m0;
         rC1_2 += m1;
         rC2_2 += m2;
         rC0_3 += m3;
         rC1_3 += m4;
         rC2_3 += m5;
         pA0 += incAk0;
         pA1 += incAk0;
         pA2 += incAk0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         pC2[4] = rC2_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC3[4] = rC2_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
